import es, popuplib, gamethread, playerlib

rotatevalue = {}
movevalue = {}

info = es.AddonInfo()
info.name = 'Build'
info.version = '1.1'
info.url = 'http://addons.eventscripts.com/addons/view/Build'
info.basename = 'build'
info.author = 'Deathyy'

es.ServerVar('build_ver', info['version'], 'A build script.').makepublic()

def player_say(ev):
    if ev['text'] == '!props':
        bh.send(ev['userid'])
        
def player_spawn(ev):
    userid = int(ev['userid'])
    playerlib.getPlayer(userid).godmode(1)
    if userid not in rotatevalue and userid not in movevalue:
        rotatevalue[userid] = 45
        movevalue[userid] = 8

def load():
    global bh, bp, bc
    
    sendMsg()
    
    bh = popuplib.create('bh')
    a = bh.addline
    a('Build')
    a('->1. Props')
    a('->2. Rotate')
    a('->3. Move')
    a('->4. Remove Prop')
    a('->5. Credits')
    a('0 Exit')
    bh.menuselect = menuHandler
    
    bp = popuplib.create('bp')
    a = bp.addline
    a('Select a Prop:')
    a('->1. Large Blast Door')
    a('->2. Small Blast Door')
    a('->3. Sofa')
    a('->4. Fence')
    a('->5. Patio Table')
    a('->6. Bed')
    a('->7. Militia TV')
    a('->8. Back')
    a('0 Exit')
    bp.menuselect = propsHandler
    
    bc = popuplib.create('bc')
    a = bc.addline
    a('Credits')
    a('Author : Deathyy')
    a('Helper : Mitch')
    a('Version : 1.0')
    a('Language : English')
    a('Coding Language : Python')
    a('Date Released : April 27 2010')
    a('OS System : Windows')
    a('->8. Back')
    a('0 Exit')
    bc.menuselect = creditsHandler
    
    
def rotateSend(userid):
    br = popuplib.create('br')
    a = br.addline
    a('Rotate')
    a('->1. +X')
    a('->2. +Y')
    a('->3. +Z')
    a('->4. -X')
    a('->5. -Y')
    a('->6. -Z')
    a('->7. Rotate Deg [%s]'%rotatevalue[userid])
    a('->8. Back')
    a('0 Exit')
    br.menuselect = rotateHandler
    br.send(userid)
    
def moveSend(userid):
    bm = popuplib.create('bm')
    a = bm.addline
    a('Move')
    a('->1. Up')
    a('->2. Left')
    a('->3. Forward')
    a('->4. Down')
    a('->5. Right')
    a('->6. Backward')
    a('->7. Move Deg [%s]'%movevalue[userid])
    a('->8. Back')
    a('0 Exit')
    bm.menuselect = moveHandler
    bm.send(userid)
    
def es_map_start(ev):
    sendMsg()
    
def sendMsg():
    gamethread.cancelDelayed('chat_msg')
    es.msg('#multi', '#green[Build] #defaultType #lightgreen!props #defaultto open the props menu.')
    gamethread.delayedname(60,'chat_msg',sendMsg)
    
def menuHandler(userid, choice, popupid):
    name = es.getplayername(userid)
    entity_index = es.ServerVar('entity_index', 0, 'The Temporary Entity')
    if choice == 1:
        bp.send(userid)
    elif choice == 2:
        rotateSend(userid)
    elif choice == 3:
        moveSend(userid)
    elif choice == 4:
        bh.send(userid)
        entity_index = getViewProp(userid)
        if int(entity_index) != 0:
            if es.createentitylist(int(entity_index))[int(entity_index)]['classname'].startswith('prop_'):
                formatname2 = 'wall_%s--%s'%(entity_index, getEntName(entity_index))
                #es.server.cmd('est_getentname formatname2 %s'%(entity_index))
                user = '--%s'%userid
                if str(user) in str(formatname2):
                    es.server.cmd('es_xremove %s' % entity_index)
                    es.tell(userid, '#multi', '#green[Build] #lightgreen%s #defaulthas removed#lightgreen %s'%(name, formatname2))
                if str(user) not in str(formatname2):
                    es.tell(userid,'#multi', '#green[Build] #defaultThat is not your prop.')
    elif choice == 5:
        bc.send(userid)
        
def propsHandler(userid, choice, popupid):
    steam = es.getplayersteamid(userid)
    name = es.getplayername(userid)
    lastgive = es.ServerVar('eventscripts_lastgive')
    if choice == 1:
        es.server.cmd('es_xprop_dynamic_create %s props_lab/blastdoor001c'%(userid))
        bp.send(userid)
        default(userid)
        check(userid, lastgive)
    elif choice == 2:
        es.server.cmd('es_xprop_dynamic_create %s props_lab/blastdoor001b'%(userid))
        bp.send(userid)
        default(userid)
        check(userid, lastgive)
    elif choice == 3:
        es.server.cmd('es_xprop_dynamic_create %s props\CS_militia\couch'%(userid))
        bp.send(userid)
        default(userid)
        check(userid, lastgive)
    elif choice == 4:
        es.server.cmd('es_xprop_dynamic_create %s props_c17/fence03a'%(userid))
        bp.send(userid)
        default(userid)
        check(userid, lastgive)
    elif choice == 5:
        es.server.cmd('es_xprop_dynamic_create %s props\de_tides\patio_table'%(userid))
        bp.send(userid)
        default(userid)
        check(userid, lastgive)
    elif choice == 6:
        es.server.cmd('es_xprop_dynamic_create %s props/de_inferno/bed'%(userid))
        bp.send(userid)
        default(userid)
        check(userid, lastgive)
    elif choice == 7:
        es.server.cmd('es_xprop_dynamic_create %s props/CS_militia/television_console01'%(userid))
        bp.send(userid)
        default(userid)
        check(userid, lastgive)
    elif choice == 8:
        bh.send(userid)
        
def default(userid):
    name = es.getplayername(userid)
    lastgive = es.ServerVar('eventscripts_lastgive')
    formatname = 'wall_%s--%s'%(lastgive, userid)
    setEntName(lastgive, formatname, userid)
    #es.server.cmd('es est_setentname %s %s' % (lastgive, formatname))
    es.tell(userid, '#multi', '#green[Build] #lightgreen%s #defaulthas spawned #lightgreen wall_%s--%s'%(name, lastgive, userid))
    
def check(userid, lastgive):
    vector2 = 'angles 0 0 0'
    formatname = 'wall_%s--%s'%(lastgive, userid)
    es.server.cmd('es_xfire %s %s addoutput "%s"' % (userid, formatname, vector2))
        
def rotateHandler(userid, choice, popupid):
    userid = int(userid)
    if choice == 1:
        rotateway(userid, choice)
    elif choice == 2:
        rotateway(userid, choice)
    elif choice == 3:
        rotateway(userid, choice)
    elif choice == 4:
        rotateway(userid, choice)
    elif choice == 5:
        rotateway(userid, choice)
    elif choice == 6:
        rotateway(userid, choice)
    elif choice == 7:
        if rotatevalue[userid] == 45:
            rotatevalue[userid] = 90
        elif rotatevalue[userid] == 90:
            rotatevalue[userid] = 5
        elif rotatevalue[userid] == 5:
            rotatevalue[userid] = 45
        rotateSend(userid)
    elif choice == 8:
        bh.send(userid)
        
def rotateway(userid, choice):
    userid = int(userid)
    rotateSend(userid)
    name = es.getplayername(userid)
    entity_index = getViewProp(userid)
    if int(entity_index) != 0:
        if es.createentitylist(int(entity_index))[int(entity_index)]['classname'].startswith('prop_'):
            formatname2 = 'wall_%s--%s'%(entity_index, getEntName(entity_index))
            #es.server.cmd('est_getentname formatname2 %s'%(entity_index))
            user = '--%s'%userid
            if str(user) in str(formatname2):
                rotation = es.getindexprop(entity_index, 'CDynamicProp.baseclass.baseclass.baseclass.m_angRotation')
                x, y, z = es.splitvectorstring(rotation)
                if choice == 1:
                    x = x + rotatevalue[userid]
                    if x == 05:
                        x = 45
                elif choice == 2:
                    y = y + rotatevalue[userid]
                    if y == 405:
                        y = 45
                elif choice == 3:
                    z = z + rotatevalue[userid]
                    if z == 405:
                        z = 45
                elif choice == 4:
                    x = x - rotatevalue[userid]
                    if x == -45:
                        x = 315
                elif choice == 5:
                    y = y - rotatevalue[userid]
                    if y == -45:
                        y = 315
                elif choice == 6:
                    z = z - rotatevalue[userid]
                    if z == -45:
                        z = 315
                vector = 'angles %s %s %s'%(x, y, z)
                walls = 'wall_%s--%s'%(entity_index, userid)
                es.server.cmd('es_xfire %s %s addoutput "%s"' % (userid, walls, vector))
            if str(user) not in str(formatname2):
                es.tell(userid,'#multi', '#green[Build] #defaultThat is not your prop.')
                    
def moveHandler(userid, choice, popupid):
    userid = int(userid)
    if choice == 1:
        moveway(userid, choice)
    elif choice == 2:
        moveway(userid, choice)
    elif choice == 3:
        moveway(userid, choice)
    elif choice == 4:
        moveway(userid, choice)
    elif choice == 5:
        moveway(userid, choice)
    elif choice == 6:
        moveway(userid, choice)
    elif choice == 7:
        if movevalue[userid] == 8:
            movevalue[userid] = 16
        elif movevalue[userid] == 16:
            movevalue[userid] = 1
        elif movevalue[userid] == 1:
            movevalue[userid] = 8
        moveSend(userid)
    elif choice == 8:
        bh.send(userid)
       
def moveway(userid, choice):
    userid = int(userid)
    moveSend(userid)
    name = es.getplayername(userid)
    entity_index = getViewProp(userid)
    if int(entity_index) != 0:
        if es.createentitylist(int(entity_index))[int(entity_index)]['classname'].startswith('prop_'):
            formatname2 = 'wall_%s--%s'%(entity_index, getEntName(entity_index))
            #es.server.cmd('est_getentname formatname2 %s'%(entity_index))
            user = "--%s"%userid
            if str(user) in str(formatname2):
                org = es.getindexprop(entity_index, 'CDynamicProp.baseclass.baseclass.baseclass.m_vecOrigin')
                x, y, z = es.splitvectorstring(org)
                if choice == 1:
                    z = z + movevalue[userid]
                elif choice == 2:
                    y = y + movevalue[userid]
                elif choice == 3:
                    x = x + movevalue[userid]
                elif choice == 4:
                    z = z - movevalue[userid]
                elif choice == 5:
                    y = y - movevalue[userid]
                elif choice == 6:
                    x = x - movevalue[userid]
                vector = 'origin %s %s %s'%(x, y, z)
                walls = 'wall_%s--%s'%(entity_index, userid)
                es.server.cmd('es_xfire %s %s addoutput "%s"' % (userid, walls, vector))
            if str(user) not in str(formatname2):
                es.tell(userid,'#multi', '#green[Build] #defaultThat is not your prop.')
                
def creditsHandler(userid, choice, popupid):
    if choice == 8:
        bh.send(userid)

def unload():
    gamethread.cancelDelayed('chat_msg')
    
def getViewProp(userid):
    oldnames = {}
    entindex = es.createentitylist()
    for index in entindex:
        oldnames[index] = es.entitygetvalue(index, "targetname")
    es.entsetname(userid,"viewed_prop")
    foundIndex = 0
    for index in entindex:
        if (es.entitygetvalue(index, "targetname") != "viewed_prop"):
            continue
        foundIndex = index
        es.entitysetvalue(index, "targetname", oldnames[index])
        break
        del oldnames[:]
        del entindex
    return foundIndex
    
def getEntName(index):
    name = ""
    name = str(es.getindexprop(index, 'CBaseEntity.predictable_id.m_PredictableID'))
    return name

def setEntName(index, name, userid):
    es.setentityname(index, name)
    es.setindexprop(index, 'CBaseEntity.predictable_id.m_PredictableID', int(userid))